/*
 *	app.h
 *	Release $Name: MATRIXSSL-3-1-OPEN $
 *	
 *	Header for MatrixSSL example sockets client and server applications
 */
/*
 *	Copyright (c) PeerSec Networks, 2002-2010. All Rights Reserved.
 *	The latest version of this code is available at http://www.matrixssl.org
 *
 *	This software is open source; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This General Public License does NOT permit incorporating this software 
 *	into proprietary programs.  If you are unable to comply with the GPL, a 
 *	commercial license for this software may be purchased from PeerSec Networks
 *	at http://www.peersec.com
 *	
 *	This program is distributed in WITHOUT ANY WARRANTY; without even the 
 *	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 *	See the GNU General Public License for more details.
 *	
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *	http://www.gnu.org/copyleft/gpl.html
 */
/******************************************************************************/

#ifndef _h_MATRIXSSLAPP
#define _h_MATRIXSSLAPP

#ifdef __cplusplus
extern "C" {
#endif
/******************************************************************************/

#include <errno.h>			/* Defines EWOULDBLOCK, etc. */
#include <fcntl.h>			/* Defines FD_CLOEXEC, etc. */

#ifdef POSIX
#include <netdb.h>			/* Defines AF_INET, etc. */
#include <unistd.h>			/* Defines close() */
#include <netinet/tcp.h>	/* Defines TCP_NODELAY, etc. */
#include <arpa/inet.h>		/* inet_addr */
#endif

#ifdef WIN32
#include <Winsock2.h>
#include <Ws2tcpip.h>

#define SIGPIPE			SIGABRT
#define snprintf		_snprintf
#define close			closesocket
#define MSG_DONTWAIT	0
#define EWOULDBLOCK		WSAEWOULDBLOCK
#define EINPROGRESS		WSAEINPROGRESS
#define strcasecmp		lstrcmpiA
#endif /* WIN32 */

#include "core/coreApi.h"

/******************************************************************************/
/*
	Configuration Options
*/
#define HTTPS_PORT		4433	/* Port to run the server/client on */

/******************************************************************************/
/*
	Platform independent socket defines for convenience
*/
#ifndef SOCKET
typedef int32 SOCKET;
#endif
#ifndef INVALID_SOCKET
#define INVALID_SOCKET	-1
#endif
	
#ifdef WIN32
#define SOCKET_ERRNO	WSAGetLastError()
#else
#define SOCKET_ERRNO	errno
#endif

/******************************************************************************/

#ifdef __cplusplus
}
#endif

#endif /* _h_MATRIXSSLAPP */

/******************************************************************************/
